Bug 824478 - Review Request: msp430mcu - Headers and linker scripts for MSP430 micro-controllers
Review Request: msp430mcu - Headers and linker scripts for MSP430 micro-contr...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Richard Marko
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2012-05-23 10:53 EDT by Rob Spanton
Modified: 2016-01-31 21:22 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-08-23 19:25:49 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
rmarko: fedora‑review+
limburgher: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description Rob Spanton 2012-05-23 10:53:52 EDT
Spec URL: http://users.ecs.soton.ac.uk/rds/rpm/mspgcc-uniarch/msp430mcu.spec
SRPM URL: http://users.ecs.soton.ac.uk/rds/rpm/mspgcc-uniarch/msp430mcu-20120406-2.fc16.src.rpm
Description: Headers and linker scripts for the Texas Instruments MSP430 range of
micro-controllers.  These headers provide the location of all the
special function registers of the micro-controllers.  The linker
scripts provide the mapping of those registers into memory as well as
information on where code should be loaded.

I'm in the process of updating the msp430 toolchain from the old gcc 3.x situation that we were shipping to the considerably newer and more functional gcc 4.x "uniarch" variant.  This upgrade involves a change in the way that the headers and linker scripts for the msp430 are delivered.  Instead of them being part of msp430-libc, they are now brought-in as a separate package called "msp430mcu".  The new msp430-libc will depend on this package.

I considered whether this package needs to be a -devel package, and consulted the fedora devel mailing list: http://thread.gmane.org/gmane.linux.redhat.fedora.devel/164102  The general conclusion is that it does not need to be since compiler toolchains are exempt from the -devel package requirement.

rpmlint outputs 0 errors and warnings when run on the specfile.  When run on the built package, it spits out a lot of warnings about headers not being in a '-devel' package.  These should be ignored (see above).

A review would be very much appreciated.
Comment 1 Richard Marko 2012-07-29 16:28:52 EDT
Package Review
==============

Key:
- = N/A
x = Pass
! = Fail
? = Not evaluated

==== C/C++ ====
[x]: MUST Package does not contain any libtool archives (.la)
[-]: MUST Package does not contain kernel modules.
[-]: MUST Package contains no static executables.
[x]: MUST Rpath absent or only used for internal libs.


==== Generic ====
[x]: EXTRA Rpmlint is run on all installed packages.
[x]: EXTRA Spec file according to URL is the same as in SRPM.
[x]: MUST Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: MUST Package successfully compiles and builds into binary rpms on at
     least one supported primary architecture.
[x]: MUST %build honors applicable compiler flags or justifies otherwise.
[x]: MUST All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: MUST Buildroot is not present
     Note: Buildroot is not needed unless packager plans to package for EPEL5
[x]: MUST Package contains no bundled libraries.
[x]: MUST Changelog in prescribed format.
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
[x]: MUST Sources contain only permissible code or content.
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
[x]: MUST Macros in Summary, %description expandable at SRPM build time.
[-]: MUST Package contains desktop file if it is a GUI application.
[-]: MUST Development files must be in a -devel package
[x]: MUST Package requires other packages for directories it uses.
[x]: MUST Package uses nothing in %doc for runtime.
[x]: MUST Package is not known to require ExcludeArch.
[x]: MUST Permissions on files are set properly.
[x]: MUST Package does not contain duplicates in %files.
[x]: MUST Package complies to the Packaging Guidelines
[x]: MUST Spec file lacks Packager, Vendor, PreReq tags.
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[-]: MUST Large documentation files are in a -doc subpackage, if required.
[x]: MUST If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %doc.
[x]: MUST License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "UNKNOWN", "*No copyright* UNKNOWN", "*No copyright* GENERATED FILE",
     "BSD (3 clause)" For detailed output of licensecheck see file:
     /home/rmarko/824478-msp430mcu/licensecheck.txt
[x]: MUST Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: MUST Package is named using only allowed ascii characters.
[x]: MUST Package is named according to the Package Naming Guidelines.
[x]: MUST Package does not generate any conflict.
     Note: Package contains no Conflicts: tag(s)
[x]: MUST Package obeys FHS, except libexecdir and /usr/target.
[x]: MUST Package must own all directories that it creates.
[x]: MUST Package does not own files or directories owned by other packages.
[x]: MUST Package installs properly.
[x]: MUST Package is not relocatable.
[x]: MUST Requires correct, justified where necessary.
[x]: MUST Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: MUST Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: MUST Spec file is legible and written in American English.
[x]: MUST Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[-]: MUST Package contains systemd file(s) if in need.
[x]: MUST File names are valid UTF-8.
[x]: SHOULD Reviewer should test that the package builds in mock.
[-]: SHOULD If the source package does not include license text(s) as a
     separate file from upstream, the packager SHOULD query upstream to
     include it.
[x]: SHOULD Dist tag is present.
[x]: SHOULD No file requires outside of /etc, /bin, /sbin, /usr/bin,
     /usr/sbin.
[x]: SHOULD Final provides and requires are sane (rpm -q --provides and rpm -q
     --requires).
[x]: SHOULD Package functions as described.
[!]: SHOULD Latest version is packaged.
[x]: SHOULD Package does not include license text files separate from
     upstream.
[x]: SHOULD Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: SHOULD SourceX / PatchY prefixed with %{name}.
[x]: SHOULD SourceX is a working URL.
[x]: SHOULD Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: SHOULD Package should compile and build into binary rpms on all supported
     architectures.
[-]: SHOULD %check is present and all tests pass.
[x]: SHOULD Packages should try to preserve timestamps of original installed
     files.
[x]: SHOULD Spec use %global instead of %define.

Issues:
[!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
     Note: Clean is needed only if supporting EPEL
See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean
[!]: MUST Each %files section contains %defattr if rpm < 4.4
     Note: defattr(....) present in %files section. This is OK if packaging
     for EPEL5. Otherwise not needed
See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
[!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
     Note: rm -rf is only needed if supporting EPEL5
[!]: SHOULD Latest version is packaged.

MD5-sum check
-------------
http://sourceforge.net/projects/mspgcc/files/msp430mcu/msp430mcu-20120406.tar.bz2 :
  MD5SUM this package     : f813c659db2d31be55e63ad7ab90837b
  MD5SUM upstream package : f813c659db2d31be55e63ad7ab90837b

Generated by fedora-review 0.2.0 (53cc903) last change: 2012-07-09
Command line :/usr/bin/fedora-review -b 824478


Rpmlint
-------

$ rpmlint *.rpm | grep -v devel-file-in-non-devel-package
msp430mcu.noarch: W: no-manual-page-for-binary msp430mcu-config
msp430mcu.noarch: W: non-standard-dir-in-usr msp430
2 packages and 0 specfiles checked; 0 errors, 457 warnings.


Removed all issues regarding -devel subpackage as this is not applicable for this package.

Package can be approved after you fix these minor issues.
Comment 2 Richard Marko 2012-07-29 16:32:19 EDT
Also I've found your DESTDIR patch applied in one of the latest releases - http://mspgcc.git.sourceforge.net/git/gitweb.cgi?p=mspgcc/msp430mcu;a=commit;h=8f0829b35b34ff1ee5f15ee6c91ddf1c05afe48c

Would be nice if in some point we can provide not only LTS releases but also more recent versions. Do you think it would be feasible and worth the effort?
Comment 3 Rob Spanton 2012-07-31 08:53:42 EDT
Hi Richard,

> [!]: MUST Package has no %clean section with rm -rf %{buildroot} (or
>      $RPM_BUILD_ROOT)
>      Note: Clean is needed only if supporting EPEL
> See: http://fedoraproject.org/wiki/Packaging/Guidelines#.25clean

Hmm.  The %clean section is already present and contains exactly that line.

> [!]: MUST Each %files section contains %defattr if rpm < 4.4
>      Note: defattr(....) present in %files section. This is OK if packaging
>      for EPEL5. Otherwise not needed
> See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions

The %files section has a %defattr line at the top...

> [!]: MUST Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
>      beginning of %install.
>      Note: rm -rf is only needed if supporting EPEL5

The %install section has exactly that line at the top.

> [!]: SHOULD Latest version is packaged.

It's still the latest LTS release version.  

> Would be nice if in some point we can provide not only LTS releases but also 
> more recent versions. Do you think it would be feasible and worth the effort?

Here's what Peter Bigot, the mspgcc maintainer, has said the LTS releases are for:

  Downstream packagers should publish only LTS releases, and should
  periodically check for new patches to be integrated into their packages
  (though I'll try to announce them periodically).

I would prefer to stick with the LTS releases, as these are the wishes of the project.

Hopefully that addresses all the issues.

Cheers,

Rob
Comment 4 Richard Marko 2012-07-31 09:18:32 EDT
Hi,

If you are not planning to support EPEL5 all the stuff mentioned is redundant and should be removed. fedora-review messages are not very clear about that.

Thanks for the LTS explanation.

- Richard
Comment 5 Rob Spanton 2012-08-14 09:31:26 EDT
Hi,

Ah, sorry, I had misunderstood those EPEL-related things.  I've now removed all those bits that generated warnings.  Here's the updated spec and SRPM:

spec: http://users.ecs.soton.ac.uk/rds/rpm/mspgcc-uniarch/msp430mcu.spec
srpm: http://users.ecs.soton.ac.uk/rds/rpm/mspgcc-uniarch/f17/msp430mcu-20120406-3.fc17.src.rpm

Cheers,

Rob
Comment 6 Richard Marko 2012-08-14 10:31:04 EDT
Hi,

thanks for the update. Approved.

- Richard
Comment 7 Rob Spanton 2012-08-14 11:46:08 EDT
New Package SCM Request
=======================
Package Name: msp430mcu
Short Description: Headers and linker scripts for MSP430 micro-controllers
Owners: rspanton
Branches: f17 f18
InitialCC:
Comment 8 Gwyn Ciesla 2012-08-14 19:42:23 EDT
Git done (by process-git-requests).

Richard, please take ownership of review BZs, thanks!
Comment 9 Richard Marko 2012-08-15 07:39:17 EDT
Sorry, I've changed the component by accident.
Comment 10 Fedora Update System 2012-08-15 08:17:22 EDT
msp430mcu-20120406-3.fc17 has been submitted as an update for Fedora 17.
https://admin.fedoraproject.org/updates/msp430mcu-20120406-3.fc17
Comment 11 Fedora Update System 2012-08-15 18:51:29 EDT
msp430mcu-20120406-3.fc17 has been pushed to the Fedora 17 testing repository.
Comment 12 Fedora Update System 2012-08-23 19:25:49 EDT
msp430mcu-20120406-3.fc17 has been pushed to the Fedora 17 stable repository.

Note You need to log in before you can comment on or make changes to this bug.